
#include "minimal.h"

#define UPPERMEM_BLOCKSIZE 1024
#define UPPERMEM_START 0x2000000
#define UPPERMEM_SIZE 0x2000000
static void *uppermem;
static int uppermap[UPPERMEM_SIZE/UPPERMEM_BLOCKSIZE];

static void * upper_malloc(size_t size)
{
  	int i=0,j=0;
 	void *mem = NULL;
 	int BSize = ((size-1)/UPPERMEM_BLOCKSIZE) + 1;

  	while (i<UPPERMEM_SIZE/UPPERMEM_BLOCKSIZE)
  	{
		for(j=0;j<BSize;j++)
  		{
    			if (uppermap[i+j])
    			{
      				i+=j;
      				i+=uppermap[i];
      				break;
    			}
  		}
		if (j==BSize) {
			uppermap[i] = BSize;
  			mem = ((char*)uppermem) + (i*UPPERMEM_BLOCKSIZE);
  			//fast_memset(mem, 0, size);
  			return mem;
  		}
	}
	return NULL;
}

void gp2x_malloc_init(void *pointer)
{
	uppermem=pointer;
	//fast_memset(uppermap,0,sizeof(uppermap));
}

void * upper_take(int Start, size_t Size)
{
	uppermap[(Start - UPPERMEM_START) / UPPERMEM_BLOCKSIZE] = ((Size-1)/UPPERMEM_BLOCKSIZE) + 1;
  	void* mem = ((char*)uppermem) + (Start-UPPERMEM_START);
	return(mem);
}

void * gp2x_malloc(size_t size)
{
	void *ptr=NULL;
	if (size>=(8*1024*1024)) {
		ptr=upper_malloc(size);
		if (ptr)
			return (ptr);
	}
	ptr=malloc(size);
	if (ptr)
		return (ptr);
	ptr=upper_malloc(size);
	if (ptr)
		return (ptr);
	return (NULL);
}

void gp2x_free(void *ptr)
{
  	int i = (((int)ptr) - ((int)uppermem));
  	if (i < 0 || i >= UPPERMEM_SIZE) {
  		if (ptr) free(ptr);
  	} else {
		uppermap[i/UPPERMEM_BLOCKSIZE] = 0;
	}
	ptr=NULL;
}

int gp2x_sizeof(void* mem)
{
  	int i = (((int)mem) - ((int)uppermem));
  	if (i < 0 || i >= UPPERMEM_SIZE)
    		return sizeof(mem);
  	else
  		return uppermap[i/UPPERMEM_BLOCKSIZE] * UPPERMEM_BLOCKSIZE;
}
